#ifndef _GENERATOR_H_
#define _GENERATOR_H_

#include <vector>
#include <map>
#include <string>

class Parser;
class Task;
class SyntaxTreeNode;
class NodeHandler;
class Token;

class Generator {

public:
	Generator(Parser &parser);
	~Generator();

	Task generate();

private:
	void addStatementToTask(Task &task, SyntaxTreeNode *node);

private:
	std::vector<SyntaxTreeNode *> myTrees;
	std::map<std::string, NodeHandler *> myNodeHandlers;
	std::map<std::string, Token> myHashTable;
};

#endif // _GENERATOR_H_
