#ifndef _PARSER_H_
#define _PARSER_H_

#include <vector>
#include <string>

class Tokenizer;
class SyntaxTreeNode;

class Parser {

public:
	Parser(Tokenizer &scanner);
	void parse(std::vector<SyntaxTreeNode *> &result) const;

private:
	enum ParserState { psStart, psWaitForLBracket, psArgument, psWaitForArgDelimiter, psFinish, psWaitForReturnValue, psWaitForSemicolon };

private:
	Tokenizer &myScanner;

private:
	void printError(std::pair<int, int> position, const std::string &error) const;
};

#endif // _PARSER_H_
