#ifndef _POLYNOMTASK_H_
#define _POLYNOMTASK_H_

#include <string>
#include "Polynom.h"

class GMPint;
struct grevlexC;

class PolynomTask {

public:
	PolynomTask();

	size_t addVariable(const std::string &var);
	size_t getVariable(const std::string &var);
	void addPolynomialCondition(Polynom<GMPint, grevlexC> condition);
	void setPolynomialQuestion(Polynom<GMPint, grevlexC> question);
	std::pair<GMPint, GMPint> getValue();

	std::string getAvailableVariableName();
	
	Polynom<GMPint, grevlexC> makeDistancePolynom(size_t x1, size_t y1, size_t x2, size_t y2, size_t dist);
	Polynom<GMPint, grevlexC> makePolynom(const std::string &poly);

private:
	VarDump myVars;
	Polynombasis<GMPint, grevlexC> myBasis;
	Polynom<GMPint, grevlexC> myQuestion;

private:
	const std::string myAvailableVariableNamePrefix;
	size_t myAvailableVariableNumber;

private:
	std::string getCurrentAvailableVariableName() const;
};

#endif // _POLYNOMTASK_H_
