#ifndef _SYNTAX_TREE_H_
#define _SYNTAX_TREE_H_

#include <vector>
#include <iostream>
#include <string>
#include <map>

class Token;

struct SyntaxTreeNode {

public:
	SyntaxTreeNode(const Token &token);

	std::string hash();

	void deleteTree();
	void deleteSubTrees();

	void dump(std::ostream &out) const;

	void addChild(SyntaxTreeNode *child);
	bool hasChildren() const;
	SyntaxTreeNode *getChild(size_t i) const;
	size_t childrenNumber() const;

	Token getToken() const;
	void setToken(const Token &token);

private:
	Token myToken;
	std::vector<SyntaxTreeNode *> myChildren;

private:
	static bool tokenLess(SyntaxTreeNode *node1, SyntaxTreeNode *node2);

};

std::ostream &operator<<(std::ostream &out, const SyntaxTreeNode &node);

#endif // SYNTAX_TREE_H_
