#ifndef CONVERTER_H_
#define CONVERTER_H_
#include "../Polynom.h"
#include "../gmpint.h"

struct Problems {

public:
  std::vector<Polynom<GMPint, grevlexC> > p;
  std::vector<std::string> t;
  std::vector<std::string> c;
};

class Converter {

public:
  virtual void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s)=0;

};

class Recognizer {

private:
  std::map<std::string, Converter*> myData;
  VarDump vd;
  Polynombasis<GMPint, grevlexC> cond;
  Problems prob;
  Problems output;

public:
  Recognizer();
  ~Recognizer();

  void recognize(const std::string& s);
  void compute();
  void read(FILE* f);
  void write(FILE* f);
  
};

class equalConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class equalNumConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class perpConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class parConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class lineConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class divConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class angleConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

//-----------------------prob

class equalProbConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class equalNumProbConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class perpProbConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class parProbConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class lineProbConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

class angleProbConverter : public Converter {

public:
  void convert(const std::vector<std::string>& v, VarDump& vd, Polynombasis<GMPint, grevlexC>& cond, Problems& prob, const std::string& s);

};

#endif
