#ifndef TESTER_H_
#define TESTER_H_
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <string>

template <class T>
void Execute(T& t) {
  DIR *dp;
  FILE *f_in, *f_out;
  dirent *ep;
  std::string s, s1, s2;
  dp = opendir (t.Folder.c_str());
  s2 = "**\n*" + t.Folder+ "*\n**";
  for (size_t foo = 0; foo != t.Folder.size(); ++foo) {
    s2 = '*' + s2 + '*';
  }
  s2 = '\n' + s2 + "\n\n";
  printf("%s", s2.c_str());
  if (dp != NULL) {
    while ((ep = readdir (dp)) != 0) {
      s = ep->d_name;
      if (s[0] != '.') {
        s1 = s.substr(s.rfind('.'));
        if (s1 == ".in") {
          printf("***\nProcessing '%s'...\n", s.c_str());
          s = t.Folder + "/" + s;
          f_in = fopen(s.c_str(), "r");
          s.erase(s.rfind('.'));
          s += ".out";
          f_out = fopen(s.c_str(), "w");

          t.test(f_in, f_out, s);

          fclose(f_in);
          fclose(f_out);
          s1 = s;
          s.erase(s.rfind('.'));
          s += ".gold";
          f_in = fopen(s.c_str(), "r");
          if (f_in == 0) { 
            printf("'%s' does not exist. Output saved in '%s'.\n", s.c_str(), s1.c_str());
          } else {
            f_out = fopen(s1.c_str(), "r");
            char* c1 = new char[8192];
            char* c2 = new char[8192];
            std::string sc1, sc2;
            char* noteof1;
            char* noteof2;
            bool equal = true;
            bool notend = true;
            while (notend) {
              noteof1 = fgets(c1, 8192, f_in);

              noteof2 = fgets(c2, 8192, f_out);
              if (!(noteof1 && noteof2)) {
                notend = false;
                if (noteof1 != noteof2) {
                  equal = false;
                }
              } else {
                sc1 = c1;
                sc2 = c2;
                if (sc2 != sc1) {
                  notend = false;
                  equal = false;
                }
              }
            }
            fclose(f_in);
            delete[] c1;
            delete[] c2;
            fclose(f_out);
            if (equal) {
              unlink(s1.c_str());
              s.erase(s.rfind('.'));
              s += ".in";
              printf("'%s' passed succesfully.\n", s.c_str());
            } else {
              printf("'%s' is not equal to '%s'. Output saved in '%s'.\n", s1.c_str(), s.c_str(), s1.c_str());
            }
          }
        }
      }
    }
    printf("***\n");
    closedir (dp);
    s2 = "***\n*/" + t.Folder+ "*\n***";
    for (size_t foo = 0; foo != t.Folder.size(); ++foo) {
      s2 = '*' + s2 + '*';
    }
    s2 = '\n' + s2 + "\n\n";
    printf("%s", s2.c_str());
  } else {
    perror ("Couldn't open the directory");
  }
}

#endif
