#include "../Polynom.impl.h"
#include <stdio.h>
#include "../tester.h"
#include "../gmpint.h"
#include <time.h>
#include <unistd.h>
#include <string>
#include <gmpxx.h>


struct Test {

  Test():Folder("Time"){};
  const std::string Folder;
  void test(FILE* f_in, FILE* f_out, std::string& s);

};

void Test::test(FILE* f_in, FILE* f_out, std::string& s) {
  char* hn = new char[255];
  gethostname(hn, 255);
  VarDump v;
  std::string ss, Type;
  char* c = new char[32];
  fgets(c, 32, f_in);
  Type=c;
  Type.erase(Type.length() - 1);
  int num;
  fscanf(f_in,"%d\n", &num);
  for (int i = 0; i != num; ++i) {
    fgets(c, 32, f_in);
    ss=c;
    ss.erase(ss.length() - 1);
    v.addVar(ss);
  }
  delete[] c;
  time_t t1, t2;
  struct tm * timedata;
  if (Type == "grevlex") {
    Polynom<GMPint, grevlexC> p1;
    Polynombasis<GMPint, grevlexC> p;
    fscanf(f_in,"%d\n", &num);
    for (int i = 0; i != num; ++i) {
      p1=v.freadPolynom<GMPint, grevlexC>(f_in);
      p.addPolynom(p1);
    }
    t1 = time(0);
    Polynombasis<GMPint, grevlexC> g = p.makeBasis_h();
    t2 = time(0);
    timedata = localtime ( &t1 );
    v.fprintBasis<GMPint, grevlexC>(f_out, g);
  }

  if (Type == "grlex") {
    Polynom<GMPint, grlexC> p1;
    Polynombasis<GMPint, grlexC> p;
    fscanf(f_in,"%d\n", &num);
    for (int i = 0; i != num; ++i) {
      p1=v.freadPolynom<GMPint, grlexC>(f_in);
      p.addPolynom(p1);
    }
    t1 = time(0);
    Polynombasis<GMPint, grlexC> g = p.makeBasis_h();
    t2 = time(0);
    timedata = localtime ( &t1 );
    v.fprintBasis<GMPint, grlexC>(f_out, g);
  }

  if (Type == "lex") {
    Polynom<GMPint, lexC> p1;
    Polynombasis<GMPint, lexC> p;
    fscanf(f_in,"%d\n", &num);
    for (int i = 0; i != num; ++i) {
      p1=v.freadPolynom<GMPint, lexC>(f_in);
      p.addPolynom(p1);
    }
    t1 = time(0);
    Polynombasis<GMPint, lexC> g = p.makeBasis_h();
    t2 = time(0);
    timedata = localtime ( &t1 );
    v.fprintBasis<GMPint, lexC>(f_out, g);
  }

  FILE* f = fopen("time.log", "a");
  fprintf(f,"\n%d/%d/%d %d:%d:%d ",timedata->tm_year+1900,timedata->tm_mon+1,timedata->tm_mday,timedata->tm_hour,timedata->tm_min,timedata->tm_sec);
  fprintf(f, "%s. ",hn);
  std::string s1 = s;
  s1.erase(s1.rfind('.'));
  fprintf(f, "%s. ", s1.c_str());
  fprintf(f,"%d sec for making.", (int)(t2 -t1));
  fclose(f);
  delete[] hn;
}

int main () {
  Test t;
  Execute(t);
  return 0;
}
