#include <fstream>

#include "gmpint.h"
#include "tokenizer.h"
#include "parser.h"
#include "generator.h"
#include "task.h"
#include "point.h"

int main(int argc, char *argv[]) {
	if (argc < 3) {
		return 1;
	}
	std::ifstream in(argv[1]);
	Tokenizer t(in);
	Parser p(t);
	Generator g(p);
	Task task = g.generate();
	in.close();
	std::ofstream out(argv[2]);
	out << task;
	out.close();
	return 0;
}
