#include <fstream>
#include <vector>

#include "tokenizer.h"
#include "syntaxtree.h"
#include "parser.h"

int main(int argc, char *argv[]) {
	if (argc < 3) {
		return 1;
	}
	std::ifstream in(argv[1]);
	Tokenizer scanner(in);
	in.close();
	Parser parser(scanner);
	std::vector<SyntaxTreeNode *> t;
	parser.parse(t);
	std::ofstream out(argv[2]);
	for (std::vector<SyntaxTreeNode *>::const_iterator i = t.begin(); i != t.end(); ++i) {
		out << *(*i);
	}
	out.close();
	return 0;
}
