#include <fstream>

#include "tokenizer.h"

int main(int argc, char *argv[]) {
	if (argc < 3)
		return 1;
	std::ifstream in(argv[1]);
	Tokenizer scanner(in);
	in.close();
	std::ofstream out(argv[2]);	
	while (scanner.hasTokens()) {
		Token t = scanner.nextToken();
		if (t.getType() == Token::ttError) {
			out << "Error[Line " << t.getPosition().first << ", Position " << t.getPosition().second << "]: " << t.getValue() << std::endl;
			out.close();
			return 1;
		}
		out << t.getValue() << std::endl;
	}
	out.close();
	return 0;
}
